part of 'navigation_state.dart';

mixin NavigationPresenter<US extends BaseState<US>> on Presenter<US> {
  NavigationState get navigationState;

  StreamSubscription<List<String>> _routesSub;

  @override
  void init() {
    _routesSub = navigationState.routes.listen((routes) {});
  }

  StateStream<List<String>> get routes => navigationState.routes;

  void pop() => navigationState._pop();

  void push(String route) => navigationState._push(route);

  void pushAndRemoveUntil(String route) => navigationState._pushAndRemoveUntil(route);

  void pushReplacement(String route) => navigationState._pushReplacement(route);

  @override
  void dispose() {
    _routesSub.cancel();
    super.dispose();
  }
}

mixin TabNavigationPresenter<US extends BaseState<US>> on Presenter<US> {
  TabNavigationState get tabNavigationState;

  void changeTab(String tab) => tabNavigationState._changeTab(tab);

  StateStream<String> get tab => tabNavigationState.tab;
}
